Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.poi.hssf.usermodel
Class EscherGraphics2d

    java.lang.Object
      java.awt.Graphics
          java.awt.Graphics2D
              org.apache.poi.hssf.usermodel.EscherGraphics2d

    public final class EscherGraphics2d

extends java.awt.Graphics2D

Translates Graphics2d calls into escher calls. The translation is lossy so many features are not supported and some just aren't implemented yet. If in doubt test the specific calls you wish to make. Graphics calls are always drawn into an EscherGroup so one will need to be created.

Important:

> One important concept worth considering is that of font size. One of the difficulties in converting Graphics calls into escher drawing calls is that Excel does not have the concept of absolute pixel positions. It measures it's cell widths in 'characters' and the cell heights in points. Unfortunately it's not defined exactly what a type of character it's measuring. Presumably this is due to the fact that the Excel will be using different fonts on different platforms or even within the same platform.

> Because of this constraint you have to calculate the verticalPointsPerPixel. This the amount the font should be scaled by when you issue commands such as drawString(). A good way to calculate this is to use the follow formula:

>           multipler = groupHeightInPoints / heightOfGroup

> The height of the group is calculated fairly simply by calculating the difference between the y coordinates of the bounding box of the shape. The height of the group can be calculated by using a convenience called `HSSFClientAnchor.getAnchorHeightInPoints()`.

Author:
  Glen Stampoultzis (glens at apache.org)

Constructor Summary
`EscherGraphics2d(EscherGraphics escherGraphics)` Constructs one escher graphics object from an escher graphics object.

Method Summary
`void` | `addRenderingHints(java.util.Map map)`
`void` | `clearRect(int i, int j, int k, int l)`
`void` | `clip(java.awt.Shape shape)`
`void` | `clipRect(int x, int y, int width, int height)`
`void` | `copyArea(int x, int y, int width, int height, int dx, int dy)`
`java.awt.Graphics` | `create()`
`void` | `dispose()`
`void` | `draw(java.awt.Shape shape)`
`void` | `drawArc(int x, int y, int width, int height, int startAngle, int arcAngle)`
`void` | `drawGlyphVector(java.awt.font.GlyphVector g, float x, float y)`
`void` | `drawImage(java.awt.image.BufferedImage bufferedimage, java.awt.image.BufferedImageOp op, int x, int y)`
`boolean` | `drawImage(java.awt.Image image, java.awt.geom.AffineTransform affinetransform, java.awt.image.ImageObserver imageobserver)`
`boolean` | `drawImage(java.awt.Image image, int x, int y, java.awt.Color bgColor, java.awt.image.ImageObserver imageobserver)`
`boolean` | `drawImage(java.awt.Image image, int x, int y, java.awt.image.ImageObserver imageobserver)`
`boolean` | `drawImage(java.awt.Image image, int dx1, int dy1, int dx2, int dy2, java.awt.Color bgColor, java.awt.image.ImageObserver imageobserver)`
`boolean` | `drawImage(java.awt.Image img, int x, int y, int width, int height, java.awt.image.ImageObserver observer)`
`boolean` | `drawImage(java.awt.Image image, int dx1, int dy1, int dx2, int dy2, int sx1, int sy1, int sx2, int sy2, java.awt.Color bgColor, java.awt.image.ImageObserver imageobserver)`
`boolean` | `drawImage(java.awt.Image image, int dx1, int dy1, int dx2, int dy2, int sx1, int sy1, int sx2, int sy2, java.awt.image.ImageObserver imageobserver)`
`void` | `drawLine(int x1, int y1, int x2, int y2)`
`void` | `drawLine(int x1, int y1, int x2, int y2, int width)`
`void` | `drawOval(int x, int y, int width, int height)`
`void` | `drawPolygon(int[] xPoints, int[] yPoints, int nPoints)`
`void` | `drawPolyline(int[] xPoints, int[] yPoints, int nPoints)`
`void` | `drawRect(int x, int y, int width, int height)`
`void` | `drawRenderableImage(java.awt.image.renderable.RenderableImage renderableimage, java.awt.geom.AffineTransform affinetransform)`
`void` | `drawRenderedImage(java.awt.image.RenderedImage renderedimage, java.awt.geom.AffineTransform affinetransform)`
`void` | `drawRoundRect(int i, int j, int k, int l, int i1, int j1)`
`void` | `drawString(java.text.AttributedCharacterIterator attributedcharacteriterator, float x, float y)`
`void` | `drawString(java.text.AttributedCharacterIterator attributedcharacteriterator, int x, int y)`
`void` | `drawString(java.lang.String string, float x, float y)`
`void` | `drawString(java.lang.String string, int x, int y)`
`void` | `fill(java.awt.Shape shape)`
`void` | `fillArc(int i, int j, int k, int l, int i1, int j1)`
`void` | `fillOval(int x, int y, int width, int height)`
`void` | `fillPolygon(int[] xPoints, int[] yPoints, int nPoints)` Fills a (closed) polygon, as defined by a pair of arrays, which hold the x and y coordinates.
`void` | `fillRect(int x, int y, int width, int height)`
`void` | `fillRoundRect(int x, int y, int width, int height, int arcWidth, int arcHeight)`
`java.awt.Color` | `getBackground()`
`java.awt.Shape` | `getClip()`
`java.awt.Rectangle` | `getClipBounds()`
`java.awt.Color` | `getColor()`
`java.awt.Composite` | `getComposite()`
`java.awt.GraphicsConfiguration` | `getDeviceConfiguration()`
`java.awt.Font` | `getFont()`
`java.awt.FontMetrics` | `getFontMetrics(java.awt.Font font)`
`java.awt.font.FontRenderContext` | `getFontRenderContext()`
`java.awt.Paint` | `getPaint()`
`java.lang.Object` | `getRenderingHint(java.awt.RenderingHints.Key key)`
`java.awt.RenderingHints` | `getRenderingHints()`
`java.awt.Stroke` | `getStroke()`
`java.awt.geom.AffineTransform` | `getTransform()`
`boolean` | `hit(java.awt.Rectangle rectangle, java.awt.Shape shape, boolean flag)`
`void` | `rotate(double d)`
`void` | `rotate(double d, double d1, double d2)`
`void` | `scale(double d, double d1)`
`void` | `setBackground(java.awt.Color c)`
`void` | `setClip(int i, int j, int k, int l)`
`void` | `setClip(java.awt.Shape shape)`
`void` | `setColor(java.awt.Color c)`
`void` | `setComposite(java.awt.Composite composite)`
`void` | `setFont(java.awt.Font font)`
`void` | `setPaint(java.awt.Paint paint1)`
`void` | `setPaintMode()`
`void` | `setRenderingHint(java.awt.RenderingHints.Key key, java.lang.Object obj)`
`void` | `setRenderingHints(java.util.Map map)`
`void` | `setStroke(java.awt.Stroke s)`
`void` | `setTransform(java.awt.geom.AffineTransform affinetransform)`
`void` | `setXORMode(java.awt.Color color1)`
`void` | `shear(double d, double d1)`
`void` | `transform(java.awt.geom.AffineTransform affinetransform)`
`void` | `translate(double d, double d1)`
`void` | `translate(int i, int j)`

Methods inherited from class java.awt.Graphics2D
`draw3DRect, fill3DRect`

Methods inherited from class java.awt.Graphics
`create, drawBytes, drawChars, drawPolygon, fillPolygon, finalize, getClipBounds, getClipRect, getFontMetrics, hitClip, toString`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### EscherGraphics2d

    public EscherGraphics2d(EscherGraphics escherGraphics)

  Constructs one escher graphics object from an escher graphics object.

  Parameters:
    `escherGraphics` - the original EscherGraphics2d object to copy

Method Detail

### addRenderingHints

    public void addRenderingHints(java.util.Map map)

  Specified by:
    `addRenderingHints` in class `java.awt.Graphics2D`

### clearRect

    public void clearRect(int i,
                          int j,
                          int k,
                          int l)

  Specified by:
    `clearRect` in class `java.awt.Graphics`

### clip

    public void clip(java.awt.Shape shape)

  Specified by:
    `clip` in class `java.awt.Graphics2D`

### clipRect

    public void clipRect(int x,
                         int y,
                         int width,
                         int height)

  Specified by:
    `clipRect` in class `java.awt.Graphics`

### copyArea

    public void copyArea(int x,
                         int y,
                         int width,
                         int height,
                         int dx,
                         int dy)

  Specified by:
    `copyArea` in class `java.awt.Graphics`

### create

    public java.awt.Graphics create()

  Specified by:
    `create` in class `java.awt.Graphics`

### dispose

    public void dispose()

  Specified by:
    `dispose` in class `java.awt.Graphics`

### draw

    public void draw(java.awt.Shape shape)

  Specified by:
    `draw` in class `java.awt.Graphics2D`

### drawArc

    public void drawArc(int x,
                        int y,
                        int width,
                        int height,
                        int startAngle,
                        int arcAngle)

  Specified by:
    `drawArc` in class `java.awt.Graphics`

### drawGlyphVector

    public void drawGlyphVector(java.awt.font.GlyphVector g,
                                float x,
                                float y)

  Specified by:
    `drawGlyphVector` in class `java.awt.Graphics2D`

### drawImage

    public boolean drawImage(java.awt.Image image,
                             int dx1,
                             int dy1,
                             int dx2,
                             int dy2,
                             int sx1,
                             int sy1,
                             int sx2,
                             int sy2,
                             java.awt.Color bgColor,
                             java.awt.image.ImageObserver imageobserver)

  Specified by:
    `drawImage` in class `java.awt.Graphics`

### drawImage

    public boolean drawImage(java.awt.Image image,
                             int dx1,
                             int dy1,
                             int dx2,
                             int dy2,
                             int sx1,
                             int sy1,
                             int sx2,
                             int sy2,
                             java.awt.image.ImageObserver imageobserver)

  Specified by:
    `drawImage` in class `java.awt.Graphics`

### drawImage

    public boolean drawImage(java.awt.Image image,
                             int dx1,
                             int dy1,
                             int dx2,
                             int dy2,
                             java.awt.Color bgColor,
                             java.awt.image.ImageObserver imageobserver)

  Specified by:
    `drawImage` in class `java.awt.Graphics`

### drawImage

    public boolean drawImage(java.awt.Image img,
                             int x,
                             int y,
                             int width,
                             int height,
                             java.awt.image.ImageObserver observer)

  Specified by:
    `drawImage` in class `java.awt.Graphics`

### drawImage

    public boolean drawImage(java.awt.Image image,
                             int x,
                             int y,
                             java.awt.Color bgColor,
                             java.awt.image.ImageObserver imageobserver)

  Specified by:
    `drawImage` in class `java.awt.Graphics`

### drawImage

    public boolean drawImage(java.awt.Image image,
                             int x,
                             int y,
                             java.awt.image.ImageObserver imageobserver)

  Specified by:
    `drawImage` in class `java.awt.Graphics`

### drawImage

    public boolean drawImage(java.awt.Image image,
                             java.awt.geom.AffineTransform affinetransform,
                             java.awt.image.ImageObserver imageobserver)

  Specified by:
    `drawImage` in class `java.awt.Graphics2D`

### drawImage

    public void drawImage(java.awt.image.BufferedImage bufferedimage,
                          java.awt.image.BufferedImageOp op,
                          int x,
                          int y)

  Specified by:
    `drawImage` in class `java.awt.Graphics2D`

### drawLine

    public void drawLine(int x1,
                         int y1,
                         int x2,
                         int y2,
                         int width)

### drawLine

    public void drawLine(int x1,
                         int y1,
                         int x2,
                         int y2)

  Specified by:
    `drawLine` in class `java.awt.Graphics`

### drawOval

    public void drawOval(int x,
                         int y,
                         int width,
                         int height)

  Specified by:
    `drawOval` in class `java.awt.Graphics`

### drawPolygon

    public void drawPolygon(int[] xPoints,
                            int[] yPoints,
                            int nPoints)

  Specified by:
    `drawPolygon` in class `java.awt.Graphics`

### drawPolyline

    public void drawPolyline(int[] xPoints,
                             int[] yPoints,
                             int nPoints)

  Specified by:
    `drawPolyline` in class `java.awt.Graphics`

### drawRect

    public void drawRect(int x,
                         int y,
                         int width,
                         int height)

  Overrides:
    `drawRect` in class `java.awt.Graphics`

### drawRenderableImage

    public void drawRenderableImage(java.awt.image.renderable.RenderableImage renderableimage,
                                    java.awt.geom.AffineTransform affinetransform)

  Specified by:
    `drawRenderableImage` in class `java.awt.Graphics2D`

### drawRenderedImage

    public void drawRenderedImage(java.awt.image.RenderedImage renderedimage,
                                  java.awt.geom.AffineTransform affinetransform)

  Specified by:
    `drawRenderedImage` in class `java.awt.Graphics2D`

### drawRoundRect

    public void drawRoundRect(int i,
                              int j,
                              int k,
                              int l,
                              int i1,
                              int j1)

  Specified by:
    `drawRoundRect` in class `java.awt.Graphics`

### drawString

    public void drawString(java.lang.String string,
                           float x,
                           float y)

  Specified by:
    `drawString` in class `java.awt.Graphics2D`

### drawString

    public void drawString(java.lang.String string,
                           int x,
                           int y)

  Specified by:
    `drawString` in class `java.awt.Graphics2D`

### drawString

    public void drawString(java.text.AttributedCharacterIterator attributedcharacteriterator,
                           float x,
                           float y)

  Specified by:
    `drawString` in class `java.awt.Graphics2D`

### drawString

    public void drawString(java.text.AttributedCharacterIterator attributedcharacteriterator,
                           int x,
                           int y)

  Specified by:
    `drawString` in class `java.awt.Graphics2D`

### fill

    public void fill(java.awt.Shape shape)

  Specified by:
    `fill` in class `java.awt.Graphics2D`

### fillArc

    public void fillArc(int i,
                        int j,
                        int k,
                        int l,
                        int i1,
                        int j1)

  Specified by:
    `fillArc` in class `java.awt.Graphics`

### fillOval

    public void fillOval(int x,
                         int y,
                         int width,
                         int height)

  Specified by:
    `fillOval` in class `java.awt.Graphics`

### fillPolygon

    public void fillPolygon(int[] xPoints,
                            int[] yPoints,
                            int nPoints)

  Fills a (closed) polygon, as defined by a pair of arrays, which hold the x and y coordinates.

  This draws the polygon, with `nPoint` line segments. The first `nPoint - 1` line segments are drawn between sequential points (`xPoints[i],yPoints[i],xPoints[i+1],yPoints[i+1]`). The final line segment is a closing one, from the last point to the first (assuming they are different).

  The area inside of the polygon is defined by using an even-odd fill rule (also known as the alternating rule), and the area inside of it is filled.

  Specified by:
    `fillPolygon` in class `java.awt.Graphics`
  Parameters:
    `xPoints` - array of the `x` coordinates.
    `yPoints` - array of the `y` coordinates.
    `nPoints` - the total number of points in the polygon.
  See Also:
    `Graphics.drawPolygon(int[], int[], int)`

### fillRect

    public void fillRect(int x,
                         int y,
                         int width,
                         int height)

  Specified by:
    `fillRect` in class `java.awt.Graphics`

### fillRoundRect

    public void fillRoundRect(int x,
                              int y,
                              int width,
                              int height,
                              int arcWidth,
                              int arcHeight)

  Specified by:
    `fillRoundRect` in class `java.awt.Graphics`

### getBackground

    public java.awt.Color getBackground()

  Specified by:
    `getBackground` in class `java.awt.Graphics2D`

### getClip

    public java.awt.Shape getClip()

  Specified by:
    `getClip` in class `java.awt.Graphics`

### getClipBounds

    public java.awt.Rectangle getClipBounds()

  Specified by:
    `getClipBounds` in class `java.awt.Graphics`

### getColor

    public java.awt.Color getColor()

  Specified by:
    `getColor` in class `java.awt.Graphics`

### getComposite

    public java.awt.Composite getComposite()

  Specified by:
    `getComposite` in class `java.awt.Graphics2D`

### getDeviceConfiguration

    public java.awt.GraphicsConfiguration getDeviceConfiguration()

  Specified by:
    `getDeviceConfiguration` in class `java.awt.Graphics2D`

### getFont

    public java.awt.Font getFont()

  Specified by:
    `getFont` in class `java.awt.Graphics`

### getFontMetrics

    public java.awt.FontMetrics getFontMetrics(java.awt.Font font)

  Specified by:
    `getFontMetrics` in class `java.awt.Graphics`

### getFontRenderContext

    public java.awt.font.FontRenderContext getFontRenderContext()

  Specified by:
    `getFontRenderContext` in class `java.awt.Graphics2D`

### getPaint

    public java.awt.Paint getPaint()

  Specified by:
    `getPaint` in class `java.awt.Graphics2D`

### getRenderingHint

    public java.lang.Object getRenderingHint(java.awt.RenderingHints.Key key)

  Specified by:
    `getRenderingHint` in class `java.awt.Graphics2D`

### getRenderingHints

    public java.awt.RenderingHints getRenderingHints()

  Specified by:
    `getRenderingHints` in class `java.awt.Graphics2D`

### getStroke

    public java.awt.Stroke getStroke()

  Specified by:
    `getStroke` in class `java.awt.Graphics2D`

### getTransform

    public java.awt.geom.AffineTransform getTransform()

  Specified by:
    `getTransform` in class `java.awt.Graphics2D`

### hit

    public boolean hit(java.awt.Rectangle rectangle,
                       java.awt.Shape shape,
                       boolean flag)

  Specified by:
    `hit` in class `java.awt.Graphics2D`

### rotate

    public void rotate(double d)

  Specified by:
    `rotate` in class `java.awt.Graphics2D`

### rotate

    public void rotate(double d,
                       double d1,
                       double d2)

  Specified by:
    `rotate` in class `java.awt.Graphics2D`

### scale

    public void scale(double d,
                      double d1)

  Specified by:
    `scale` in class `java.awt.Graphics2D`

### setBackground

    public void setBackground(java.awt.Color c)

  Specified by:
    `setBackground` in class `java.awt.Graphics2D`

### setClip

    public void setClip(int i,
                        int j,
                        int k,
                        int l)

  Specified by:
    `setClip` in class `java.awt.Graphics`

### setClip

    public void setClip(java.awt.Shape shape)

  Specified by:
    `setClip` in class `java.awt.Graphics`

### setColor

    public void setColor(java.awt.Color c)

  Specified by:
    `setColor` in class `java.awt.Graphics`

### setComposite

    public void setComposite(java.awt.Composite composite)

  Specified by:
    `setComposite` in class `java.awt.Graphics2D`

### setFont

    public void setFont(java.awt.Font font)

  Specified by:
    `setFont` in class `java.awt.Graphics`

### setPaint

    public void setPaint(java.awt.Paint paint1)

  Specified by:
    `setPaint` in class `java.awt.Graphics2D`

### setPaintMode

    public void setPaintMode()

  Specified by:
    `setPaintMode` in class `java.awt.Graphics`

### setRenderingHint

    public void setRenderingHint(java.awt.RenderingHints.Key key,
                                 java.lang.Object obj)

  Specified by:
    `setRenderingHint` in class `java.awt.Graphics2D`

### setRenderingHints

    public void setRenderingHints(java.util.Map map)

  Specified by:
    `setRenderingHints` in class `java.awt.Graphics2D`

### setStroke

    public void setStroke(java.awt.Stroke s)

  Specified by:
    `setStroke` in class `java.awt.Graphics2D`

### setTransform

    public void setTransform(java.awt.geom.AffineTransform affinetransform)

  Specified by:
    `setTransform` in class `java.awt.Graphics2D`

### setXORMode

    public void setXORMode(java.awt.Color color1)

  Specified by:
    `setXORMode` in class `java.awt.Graphics`

### shear

    public void shear(double d,
                      double d1)

  Specified by:
    `shear` in class `java.awt.Graphics2D`

### transform

    public void transform(java.awt.geom.AffineTransform affinetransform)

  Specified by:
    `transform` in class `java.awt.Graphics2D`

### translate

    public void translate(double d,
                          double d1)

  Specified by:
    `translate` in class `java.awt.Graphics2D`

### translate

    public void translate(int i,
                          int j)

  Specified by:
    `translate` in class `java.awt.Graphics2D`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD